--- old/usr/src/tools/smatch/src/check_locking.c	Tue Jan  7 08:01:52 2020
+++ new/usr/src/tools/smatch/src/check_locking.c	Tue Jan  7 08:01:52 2020
@@ -982,17 +1262,29 @@
 {
 	my_id = id;
 
-	if (option_project == PROJ_WINE)
-		load_table(wine_lock_table, ARRAY_SIZE(wine_lock_table));
-	else if (option_project == PROJ_KERNEL)
-		load_table(kernel_lock_table, ARRAY_SIZE(kernel_lock_table));
-	else
+	if (option_project != PROJ_KERNEL)
 		return;
 
+	load_table(lock_table);
+
+	set_dynamic_states(my_id);
 	add_unmatched_state_hook(my_id, &unmatched_state);
 	add_pre_merge_hook(my_id, &pre_merge_hook);
-	add_split_return_callback(match_return);
+	add_merge_hook(my_id, &merge_func);
+	add_modification_hook(my_id, &reset);
+
 	add_hook(&match_func_end, END_FUNC_HOOK);
+
 	add_hook(&match_after_func, AFTER_FUNC_HOOK);
+	add_hook(&match_save_states, INLINE_FN_START);
+	add_hook(&match_restore_states, INLINE_FN_END);
 
+	add_hook(&match_call_info, FUNCTION_CALL_HOOK);
+
+	add_split_return_callback(match_return_info);
+	select_return_states_hook(LOCKED, &db_param_locked);
+	select_return_states_hook(UNLOCKED, &db_param_unlocked);
+	select_return_states_hook(LOCK_RESTORED, &db_param_restore);
+
+	return_implies_state("dma_resv_lock", -4095, -1, &match_dma_resv_lock_NULL, 0);
 }
--- old/usr/src/tools/smatch/src/check_param_mapper.c	Tue Jan  7 08:01:52 2020
+++ new/usr/src/tools/smatch/src/check_param_mapper.c	Tue Jan  7 08:01:52 2020
@@ -23,7 +23,7 @@
  * }
  *
  * Passing "bar" to foo() really means passing "bar" to baz();
- * 
+ *
  * In this case it would print:
  * info: param_mapper 0 => bar 1
  *
@@ -33,54 +33,6 @@
 
 static int my_id;
 
-STATE(argument);
-
-static struct symbol *func_sym;
-
-static void delete(struct sm_state *sm, struct expression *mod_expr)
-{
-	set_state(my_id, sm->name, sm->sym, &undefined);
-}
-
-static void match_function_def(struct symbol *sym)
-{
-	struct symbol *arg;
-
-	func_sym = sym;
-	FOR_EACH_PTR(func_sym->ctype.base_type->arguments, arg) {
-		if (!arg->ident) {
-			continue;
-		}
-		set_state(my_id, arg->ident->name, arg, &argument);
-	} END_FOR_EACH_PTR(arg);
-}
-
-static int get_arg_num(struct expression *expr)
-{
-	struct smatch_state *state;
-	struct symbol *arg;
-	struct symbol *this_arg;
-	int i;
-
-	expr = strip_expr(expr);
-	if (expr->type != EXPR_SYMBOL)
-		return -1;
-	this_arg = expr->symbol;
-
-	state = get_state_expr(my_id, expr);
-	if (!state || state != &argument)
-		return -1;
-	
-	i = 0;
-	FOR_EACH_PTR(func_sym->ctype.base_type->arguments, arg) {
-		if (arg == this_arg)
-			return i;
-		i++;
-	} END_FOR_EACH_PTR(arg);
-
-	return -1;
-}
-
 static void match_call(struct expression *expr)
 {
 	struct expression *tmp;
@@ -93,22 +45,25 @@
 
 	func = expr->fn->symbol_name->name;
 
-	i = 0;
+	i = -1;
 	FOR_EACH_PTR(expr->args, tmp) {
-		tmp = strip_expr(tmp);
-		arg_num = get_arg_num(tmp);
-		if (arg_num >= 0)
-			sm_msg("info: param_mapper %d => %s %d", arg_num, func, i);
 		i++;
+		tmp = strip_expr(tmp);
+		if (tmp->type != EXPR_SYMBOL)
+			continue;
+		if (param_was_set(tmp))
+			continue;
+		arg_num = get_param_num_from_sym(tmp->symbol);
+		if (arg_num < 0)
+			continue;
+		sm_msg("info: param_mapper %d => %s %d", arg_num, func, i);
 	} END_FOR_EACH_PTR(tmp);
 }
 
 void check_param_mapper(int id)
 {
-	if (!option_param_mapper)
+	if (!option_info)
 		return;
 	my_id = id;
-	add_modification_hook(my_id, &delete);
-	add_hook(&match_function_def, FUNC_DEF_HOOK);
 	add_hook(&match_call, FUNCTION_CALL_HOOK);
 }
--- old/usr/src/tools/smatch/src/smatch.c	Tue Jan  7 08:01:52 2020
+++ new/usr/src/tools/smatch/src/smatch.c	Tue Jan  7 08:01:52 2020
@@ -34,7 +34,6 @@
 int option_spammy = 0;
 int option_info = 0;
 int option_full_path = 0;
-int option_param_mapper = 0;
 int option_call_tree = 0;
 int option_no_db = 0;
 int option_enable = 0;
@@ -142,7 +141,6 @@
 	printf("--spammy:  print superfluous crap.\n");
 	printf("--info:  print info used to fill smatch_data/.\n");
 	printf("--debug:  print lots of debug output.\n");
-	printf("--param-mapper:  enable param_mapper output.\n");
 	printf("--no-data:  do not use the /smatch_data/ directory.\n");
 	printf("--data=<dir>: overwrite path to default smatch data directory.\n");
 	printf("--full-path:  print the full pathname.\n");
@@ -235,7 +233,6 @@
 		OPTION(no_data);
 		OPTION(two_passes);
 		OPTION(full_path);
-		OPTION(param_mapper);
 		OPTION(call_tree);
 		OPTION(file_output);
 		OPTION(time);
--- old/usr/src/tools/smatch/src/smatch.h	Tue Jan  7 08:01:53 2020
+++ new/usr/src/tools/smatch/src/smatch.h	Tue Jan  7 08:01:53 2020
@@ -23,6 +23,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <limits.h>
+#include <float.h>
 #include <sys/time.h>
 #include <sqlite3.h>
 #include "lib.h"
@@ -37,6 +38,9 @@
 	union {
 		long long value;
 		unsigned long long uvalue;
+		float fvalue;
+		double dvalue;
+		long double ldvalue;
 	};
 } sval_t;
 
@@ -206,6 +210,7 @@
 extern struct symbol *cur_func_sym;
 extern int option_debug;
 extern int local_debug;
+extern int debug_db;
 bool debug_implied(void);
 extern int option_info;
 extern int option_spammy;
@@ -240,7 +245,10 @@
  * sm_msg(): other message (please avoid using this)
  */
 
-#define sm_printf(msg...) do { if (final_pass || option_debug || local_debug) fprintf(sm_outfd, msg); } while (0)
+#define sm_printf(msg...) do {						\
+	if (final_pass || option_debug || local_debug || debug_db)	\
+		fprintf(sm_outfd, msg);					\
+} while (0)
 
 static inline void sm_prefix(void)
 {
@@ -254,7 +262,7 @@
 #define sm_print_msg(type, msg...) \
 do {                                                           \
 	print_implied_debug_msg();                             \
-	if (!final_pass && !option_debug && !local_debug)      \
+	if (!final_pass && !option_debug && !local_debug && !debug_db)	  \
 		break;                                         \
 	if (__silence_warnings_for_stmt && !option_debug && !local_debug) \
 		break;					       \
@@ -277,12 +285,6 @@
 
 #define sm_msg(msg...) do { sm_print_msg(0, msg); } while (0)
 
-#define local_debug(msg...)					\
-do {								\
-	if (local_debug)					\
-		sm_msg(msg);					\
-} while (0)
-
 extern char *implied_debug_msg;
 static inline void print_implied_debug_msg(void)
 {
@@ -297,6 +299,7 @@
 }
 
 #define sm_debug(msg...) do { if (option_debug) sm_printf(msg); } while (0)
+#define db_debug(msg...) do { if (option_debug || debug_db) sm_printf(msg); } while (0)
 
 #define sm_info(msg...) do {					\
 	if (option_debug || (option_info && final_pass)) {	\
@@ -438,6 +441,7 @@
 struct expression *get_last_expr_from_expression_stmt(struct expression *expr);
 int get_param_num_from_sym(struct symbol *sym);
 int get_param_num(struct expression *expr);
+struct symbol *get_param_sym_from_num(int num);
 int ms_since(struct timeval *start);
 int parent_is_gone_var_sym(const char *name, struct symbol *sym);
 int parent_is_gone(struct expression *expr);
@@ -806,8 +810,6 @@
 	RETURN_VALUE	= 1005,
 	DEREFERENCE	= 1006,
 	RANGE_CAP	= 1007,
-	LOCK_HELD	= 1008,
-	LOCK_RELEASED	= 1009,
 	ABSOLUTE_LIMITS	= 1010,
 	PARAM_ADD	= 1012,
 	PARAM_FREED	= 1013,
@@ -845,6 +847,10 @@
 	NO_OVERFLOW_SIMPLE = 8019,
 	LOCKED		= 8020,
 	UNLOCKED	= 8021,
+	HALF_LOCKED	= 9022,
+	LOCK_RESTORED	= 9023,
+	KNOWN_LOCKED	= 9024,
+	KNOWN_UNLOCKED 	= 9025,
 	SET_FS		= 8022,
 	ATOMIC_INC	= 8023,
 	ATOMIC_DEC	= 8024,
@@ -887,6 +893,7 @@
 const char *get_mtag_name_var_sym(const char *state_name, struct symbol *sym);
 const char *get_mtag_name_expr(struct expression *expr);
 char *get_data_info_name(struct expression *expr);
+char *sm_to_arg_name(struct expression *expr, struct sm_state *sm);
 int is_recursive_member(const char *param_name);
 
 char *escape_newlines(const char *str);
@@ -897,7 +904,7 @@
 	char sql_txt[1024];							\
 										\
 	sqlite3_snprintf(sizeof(sql_txt), sql_txt, sql);			\
-	sm_debug("debug: %s\n", sql_txt);					\
+	db_debug("debug: %s\n", sql_txt);					\
 	sql_exec(db, call_back, data, sql_txt);					\
 } while (0)
 
@@ -931,7 +938,7 @@
 			      ignore ? "or ignore " : "", #table);		\
 		p += snprintf(p, buf + sizeof(buf) - p, values);		\
 		p += snprintf(p, buf + sizeof(buf) - p, ");");			\
-		sm_debug("mem-db: %s\n", buf);					\
+		db_debug("mem-db: %s\n", buf);					\
 		rc = sqlite3_exec(_db, buf, NULL, NULL, &err);			\
 		if (rc != SQLITE_OK) {						\
 			sm_ierror("SQL error #2: %s", err);			\
@@ -1007,7 +1014,6 @@
 extern char *data_dir;
 extern int option_no_data;
 extern int option_full_path;
-extern int option_param_mapper;
 extern int option_call_tree;
 extern int num_checks;
 
@@ -1062,6 +1068,7 @@
 char *map_call_to_param_name_sym(struct expression *expr, struct symbol **sym);
 
 /* smatch_comparison.c */
+extern int comparison_id;
 #define UNKNOWN_COMPARISON 0
 #define IMPOSSIBLE_COMPARISON -1
 struct compare_data {
@@ -1117,8 +1124,11 @@
 sval_t *sval_alloc_permanent(sval_t sval);
 sval_t sval_blank(struct expression *expr);
 sval_t sval_type_val(struct symbol *type, long long val);
+sval_t sval_type_fval(struct symbol *type, long double fval);
 sval_t sval_from_val(struct expression *expr, long long val);
+sval_t sval_from_fval(struct expression *expr, long double fval);
 int sval_is_ptr(sval_t sval);
+bool sval_is_fp(sval_t sval);
 int sval_unsigned(sval_t sval);
 int sval_signed(sval_t sval);
 int sval_bits(sval_t sval);
@@ -1171,6 +1181,10 @@
 struct sm_state *stored_condition_implication_hook(struct expression *expr,
 			struct state_list **true_stack,
 			struct state_list **false_stack);
+/* smatch_parsed_conditions.c */
+struct sm_state *parsed_condition_implication_hook(struct expression *expr,
+			struct state_list **true_stack,
+			struct state_list **false_stack);
 
 /* check_string_len.c */
 int get_formatted_string_size(struct expression *call, int arg);
@@ -1272,6 +1286,14 @@
 		type->type == SYM_FN);
 }
 
+static inline bool type_is_fp(struct symbol *type)
+{
+	return type &&
+	       (type == &float_ctype ||
+		type == &double_ctype ||
+		type == &ldouble_ctype);
+}
+
 static inline int type_bits(struct symbol *type)
 {
 	if (!type)
@@ -1313,10 +1335,53 @@
 /*
  * Returns -1 if one is smaller, 0 if they are the same and 1 if two is larger.
  */
+
+static inline int fp_cmp(sval_t one, sval_t two)
+{
+	struct symbol *type;
+
+	if (sval_is_fp(one) && sval_is_fp(two))
+		type = type_bits(one.type) > type_bits(two.type) ? one.type : two.type;
+	else if (sval_is_fp(one))
+		type = one.type;
+	else
+		type = two.type;
+
+	one = sval_cast(type, one);
+	two = sval_cast(type, two);
+
+	if (one.type == &float_ctype) {
+		if (one.fvalue < two.fvalue)
+			return -1;
+		if (one.fvalue == two.fvalue)
+			return 0;
+		return 1;
+	}
+	if (one.type == &double_ctype) {
+		if (one.dvalue < two.dvalue)
+			return -1;
+		if (one.dvalue == two.dvalue)
+			return 0;
+		return 1;
+	}
+	if (one.type == &ldouble_ctype) {
+		if (one.ldvalue < two.ldvalue)
+			return -1;
+		if (one.ldvalue == two.ldvalue)
+			return 0;
+		return 1;
+	}
+	sm_perror("bad type in fp_cmp(): %s", type_to_str(type));
+	return 1;
+}
+
 static inline int sval_cmp(sval_t one, sval_t two)
 {
 	struct symbol *type;
 
+	if (sval_is_fp(one) || sval_is_fp(two))
+		return fp_cmp(one, two);
+
 	type = one.type;
 	if (sval_positive_bits(two) > sval_positive_bits(one))
 		type = two.type;
--- old/usr/src/tools/smatch/src/smatch_address.c	Tue Jan  7 08:01:53 2020
+++ new/usr/src/tools/smatch/src/smatch_address.c	Tue Jan  7 08:01:53 2020
@@ -119,6 +119,11 @@
 	struct ident *member;
 	int offset;
 
+	/*
+	 * FIXME: This doesn't handle foo.u.bar correctly.
+	 *
+	 */
+
 	if (expr->type != EXPR_DEREF)  /* hopefully, this doesn't happen */
 		return -1;
 
@@ -202,25 +207,66 @@
 	if (!sym)
 		return NULL;
 
+	/* This should just be the mtag if it's not on the stack */
 	return alloc_rl(valid_ptr_min_sval, valid_ptr_max_sval);
 }
 
+static bool handle_fn_address(struct expression *expr, struct range_list **rl)
+{
+	struct symbol *type;
+
+	if (expr->type == EXPR_PREOP && expr->op == '&')
+		expr = strip_expr(expr->unop);
+
+	if (expr->type != EXPR_SYMBOL)
+		return false;
+
+	type = get_type(expr);
+	if (!type || type->type != SYM_FN)
+		return false;
+
+	*rl = alloc_rl(valid_ptr_min_sval, valid_ptr_max_sval);
+	return true;
+}
+
 int get_address_rl(struct expression *expr, struct range_list **rl)
 {
 	struct expression *unop;
 
+	/*
+	 * Ugh...  This function is bad.  It doesn't work where it's supposed to
+	 * and it does more than it really should.  It shouldn't handle string
+	 * literals I think...
+	 *
+	 * There are several complications.  For arrays and functions the "&foo"
+	 * "foo" are equivalent.  But the problem is that we're also passing in
+	 * foo->array[] and foo->fn.
+	 *
+	 * Then, when we have foo->bar.baz.one.two; that needs to be handled
+	 * correctly but right now, it is not.
+	 *
+	 */
+
 	expr = strip_expr(expr);
 	if (!expr)
 		return 0;
 
-	if (expr->type == EXPR_STRING) {
-		*rl = alloc_rl(valid_ptr_min_sval, valid_ptr_max_sval);
+	/*
+	 * For functions &fn and fn are equivalent.  I don't know if this is
+	 * really the right place to handle it, but let's just get it out of the
+	 * way for now.
+	 *
+	 */
+	if (handle_fn_address(expr, rl))
 		return 1;
-	}
 
-	if (expr->type == EXPR_PREOP && expr->op == '&')
+	/*
+	 * For arrays, &foo->array and foo->array are equivalent.
+	 *
+	 */
+	if (expr->type == EXPR_PREOP && expr->op == '&') {
 		expr = strip_expr(expr->unop);
-	else {
+	} else {
 		struct symbol *type;
 
 		type = get_type(expr);
--- old/usr/src/tools/smatch/src/smatch_buf_size.c	Tue Jan  7 08:01:53 2020
+++ new/usr/src/tools/smatch/src/smatch_buf_size.c	Tue Jan  7 08:01:53 2020
@@ -910,6 +910,7 @@
 		add_allocation_function("kzalloc_node", &match_alloc, 0);
 		add_allocation_function("vmalloc", &match_alloc, 0);
 		add_allocation_function("__vmalloc", &match_alloc, 0);
+		add_allocation_function("kvmalloc", &match_alloc, 0);
 		add_allocation_function("kcalloc", &match_calloc, 0);
 		add_allocation_function("kmalloc_array", &match_calloc, 0);
 		add_allocation_function("drm_malloc_ab", &match_calloc, 0);
--- old/usr/src/tools/smatch/src/smatch_comparison.c	Tue Jan  7 08:01:53 2020
+++ new/usr/src/tools/smatch/src/smatch_comparison.c	Tue Jan  7 08:01:53 2020
@@ -32,7 +32,7 @@
 #include "smatch_extra.h"
 #include "smatch_slist.h"
 
-static int compare_id;
+int comparison_id;
 static int link_id;
 static int inc_dec_id;
 static int inc_dec_link_id;
@@ -542,6 +542,7 @@
 	int extra, new;
 	static bool in_recurse;
 
+	// FIXME.  No data is useless
 	if (!data)
 		return;
 
@@ -556,7 +557,8 @@
 	if (new == data->comparison)
 		return;
 
-	set_state(compare_id, cur->name, NULL,
+	// FIXME: we should always preserve implications
+	set_state(comparison_id, cur->name, NULL,
 		  alloc_compare_state(data->left, data->left_var, data->left_vsl,
 				      new,
 				      data->right, data->right_var, data->right_vsl));
@@ -624,7 +626,7 @@
 				NULL, param->ident->name, left_vsl,
 				SPECIAL_EQUAL,
 				NULL, alloc_sname(orig), right_vsl);
-		set_state(compare_id, state_name, NULL, state);
+		set_state(comparison_id, state_name, NULL, state);
 
 		link = alloc_sname(state_name);
 		links = NULL;
@@ -675,7 +677,7 @@
 	links = sm->state->data;
 
 	FOR_EACH_PTR(links, tmp) {
-		state = get_state(compare_id, tmp, NULL);
+		state = get_state(comparison_id, tmp, NULL);
 		if (!state)
 			continue;
 		data = state->data;
@@ -701,7 +703,7 @@
 					data->left, data->left_var, data->left_vsl,
 					flip ? '<' : '>',
 					data->right, data->right_var, data->right_vsl);
-			set_state(compare_id, tmp, NULL, new);
+			set_state(comparison_id, tmp, NULL, new);
 			break;
 		case '<':
 		case SPECIAL_UNSIGNED_LT:
@@ -709,7 +711,7 @@
 					data->left, data->left_var, data->left_vsl,
 					flip ? SPECIAL_GTE : SPECIAL_LTE,
 					data->right, data->right_var, data->right_vsl);
-			set_state(compare_id, tmp, NULL, new);
+			set_state(comparison_id, tmp, NULL, new);
 			break;
 		default:
 			new = alloc_compare_state(
@@ -716,7 +718,7 @@
 					data->left, data->left_var, data->left_vsl,
 					UNKNOWN_COMPARISON,
 					data->right, data->right_var, data->right_vsl);
-			set_state(compare_id, tmp, NULL, new);
+			set_state(comparison_id, tmp, NULL, new);
 		}
 	} END_FOR_EACH_PTR(tmp);
 }
@@ -733,7 +735,7 @@
 		struct compare_data *data;
 		struct smatch_state *new;
 
-		state = get_state(compare_id, tmp, NULL);
+		state = get_state(comparison_id, tmp, NULL);
 		if (!state || !state->data)
 			continue;
 
@@ -752,7 +754,7 @@
 					data->left, data->left_var, data->left_vsl,
 					'<',
 					data->right, data->right_var, data->right_vsl);
-			set_state(compare_id, tmp, NULL, new);
+			set_state(comparison_id, tmp, NULL, new);
 			break;
 			}
 		default:
@@ -760,7 +762,7 @@
 					data->left, data->left_var, data->left_vsl,
 					UNKNOWN_COMPARISON,
 					data->right, data->right_var, data->right_vsl);
-			set_state(compare_id, tmp, NULL, new);
+			set_state(comparison_id, tmp, NULL, new);
 		}
 	} END_FOR_EACH_PTR(tmp);
 }
@@ -775,7 +777,7 @@
 	FOR_EACH_PTR(links, tmp) {
 		struct smatch_state *old, *new;
 
-		old = get_state(compare_id, tmp, NULL);
+		old = get_state(comparison_id, tmp, NULL);
 		if (!old || !old->data) {
 			new = &undefined;
 		} else {
@@ -786,7 +788,7 @@
 					UNKNOWN_COMPARISON,
 					data->right, data->right_var, data->right_vsl);
 		}
-		set_state(compare_id, tmp, NULL, new);
+		set_state(comparison_id, tmp, NULL, new);
 	} END_FOR_EACH_PTR(tmp);
 	set_state(link_id, sm->name, sm->sym, &undefined);
 }
@@ -988,7 +990,7 @@
 	}
 
 	snprintf(state_name, sizeof(state_name), "%s vs %s", left, right);
-	state = get_state_stree(pre_stree, compare_id, state_name, NULL);
+	state = get_state_stree(pre_stree, comparison_id, state_name, NULL);
 	if (!state || !state->data)
 		return 0;
 	data = state->data;
@@ -1041,7 +1043,7 @@
 	struct var_sym *vs;
 
 	FOR_EACH_PTR(links, tmp) {
-		state = get_state_stree(pre_stree, compare_id, tmp, NULL);
+		state = get_state_stree(pre_stree, comparison_id, tmp, NULL);
 		if (!state || !state->data)
 			continue;
 		data = state->data;
@@ -1100,7 +1102,7 @@
 			false_state = NULL;
 
 		snprintf(state_name, sizeof(state_name), "%s vs %s", left_var, right_var);
-		set_true_false_states(compare_id, state_name, NULL, true_state, false_state);
+		set_true_false_states(comparison_id, state_name, NULL, true_state, false_state);
 		FOR_EACH_PTR(left_vsl, vs) {
 			save_link_var_sym(vs->var, vs->sym, state_name);
 		} END_FOR_EACH_PTR(vs);
@@ -1199,7 +1201,8 @@
 			SPECIAL_EQUAL,
 			data->right, data->right_var, data->right_vsl);
 
-	set_true_false_states(compare_id, state_name, NULL, NULL, false_state);
+	// FIXME: This doesn't handle links correct so it doesn't set "param orig"
+	set_true_false_states(comparison_id, state_name, NULL, NULL, false_state);
 }
 
 static int is_plus_one(struct expression *expr)
@@ -1340,7 +1343,7 @@
 	update_tf_data(pre_stree, left_expr, left, left_vsl, right_expr, right, right_vsl, op, false_op);
 	free_stree(&pre_stree);
 
-	set_true_false_states(compare_id, state_name, NULL, true_state, false_state);
+	set_true_false_states(comparison_id, state_name, NULL, true_state, false_state);
 	__compare_param_limit_hook(left_expr, right_expr, state_name, true_state, false_state);
 	save_link(left_expr, state_name);
 	save_link(right_expr, state_name);
@@ -1442,7 +1445,7 @@
 			comparison,
 			right_expr, right_name, right_vsl);
 
-	set_state(compare_id, state_name, NULL, state);
+	set_state(comparison_id, state_name, NULL, state);
 
 	FOR_EACH_PTR(left_vsl, vs) {
 		save_link_var_sym(vs->var, vs->sym, state_name);
@@ -1492,7 +1495,7 @@
 			comparison,
 			right, right_name, right_vsl);
 
-	set_state(compare_id, state_name, NULL, state);
+	set_state(comparison_id, state_name, NULL, state);
 	save_link(left, state_name);
 	save_link(right, state_name);
 
@@ -1609,7 +1612,7 @@
 	links = state->data;
 
 	FOR_EACH_PTR(links, tmp) {
-		state = get_state(compare_id, tmp, NULL);
+		state = get_state(comparison_id, tmp, NULL);
 		if (!state || !state->data)
 			continue;
 		data = state->data;
@@ -1678,7 +1681,7 @@
 	}
 
 	snprintf(buf, sizeof(buf), "%s vs %s", one, two);
-	state = get_state(compare_id, buf, NULL);
+	state = get_state(comparison_id, buf, NULL);
 	if (state)
 		ret = state_to_comparison(state);
 
@@ -1784,7 +1787,7 @@
 	}
 
 	snprintf(buf, sizeof(buf), "%s vs %s", one, two);
-	sm = get_sm_state(compare_id, buf, NULL);
+	sm = get_sm_state(comparison_id, buf, NULL);
 	if (!sm)
 		goto free;
 
@@ -1825,7 +1828,7 @@
 	links = state->data;
 
 	FOR_EACH_PTR(links, tmp) {
-		sm = get_sm_state(compare_id, tmp, NULL);
+		sm = get_sm_state(comparison_id, tmp, NULL);
 		if (!sm)
 			continue;
 		// FIXME have to compare name with vsl
@@ -1849,7 +1852,7 @@
 	links = state->data;
 
 	FOR_EACH_PTR(links, tmp) {
-		sm = get_sm_state(compare_id, tmp, NULL);
+		sm = get_sm_state(comparison_id, tmp, NULL);
 		if (!sm)
 			continue;
 		if (!strchr(sm->state->name, '='))
@@ -1879,7 +1882,7 @@
 	links = state->data;
 
 	FOR_EACH_PTR(links, link) {
-		sm = get_sm_state(compare_id, link, NULL);
+		sm = get_sm_state(comparison_id, link, NULL);
 		if (!sm)
 			continue;
 		FOR_EACH_PTR(sm->possible, possible) {
@@ -1924,7 +1927,7 @@
 	links = state->data;
 
 	FOR_EACH_PTR(links, tmp) {
-		state = get_state(compare_id, tmp, NULL);
+		state = get_state(comparison_id, tmp, NULL);
 		if (!state || !state->data)
 			continue;
 		data = state->data;
@@ -2173,7 +2176,7 @@
 
 			if (strstr(link, " orig"))
 				continue;
-			sm = get_sm_state(compare_id, link, NULL);
+			sm = get_sm_state(comparison_id, link, NULL);
 			if (!sm)
 				continue;
 			data = sm->state->data;
@@ -2228,7 +2231,7 @@
 
 	links = link_sm->state->data;
 	FOR_EACH_PTR(links, link) {
-		compare_sm = get_sm_state(compare_id, link, NULL);
+		compare_sm = get_sm_state(comparison_id, link, NULL);
 		if (!compare_sm)
 			continue;
 		data = compare_sm->state->data;
@@ -2321,7 +2324,7 @@
 			continue;
 		links = tmp->state->data;
 		FOR_EACH_PTR(links, link) {
-			sm = get_sm_state(compare_id, link, NULL);
+			sm = get_sm_state(comparison_id, link, NULL);
 			if (!sm)
 				continue;
 			data = sm->state->data;
@@ -2539,7 +2542,7 @@
 		goto free;
 
 	snprintf(buf, sizeof(buf), "%s vs %s", left_name, right_name);
-	state = get_state(compare_id, buf, NULL);
+	state = get_state(comparison_id, buf, NULL);
 	if (!state)
 		goto free;
 	state_op = state_to_comparison(state);
@@ -2573,7 +2576,7 @@
 
 	links = link_state->data;
 	FOR_EACH_PTR(links, link) {
-		sm = get_sm_state(compare_id, link, NULL);
+		sm = get_sm_state(comparison_id, link, NULL);
 		if (!sm)
 			continue;
 		data = sm->state->data;
@@ -2595,12 +2598,12 @@
 
 void register_comparison(int id)
 {
-	compare_id = id;
-	set_dynamic_states(compare_id);
+	comparison_id = id;
+	set_dynamic_states(comparison_id);
 	add_hook(&save_start_states, AFTER_DEF_HOOK);
-	add_unmatched_state_hook(compare_id, unmatched_comparison);
-	add_pre_merge_hook(compare_id, &pre_merge_hook);
-	add_merge_hook(compare_id, &merge_compare_states);
+	add_unmatched_state_hook(comparison_id, unmatched_comparison);
+	add_pre_merge_hook(comparison_id, &pre_merge_hook);
+	add_merge_hook(comparison_id, &merge_compare_states);
 	add_hook(&free_data, AFTER_FUNC_HOOK);
 	add_hook(&match_call_info, FUNCTION_CALL_HOOK);
 	add_split_return_callback(&print_return_comparison);
@@ -2639,9 +2642,60 @@
 	set_up_link_functions(inc_dec_id, inc_dec_link_id);
 }
 
+static struct sm_state *clone_partial_sm(struct sm_state *sm, int comparison)
+{
+	struct compare_data *data;
+	struct sm_state *clone;
+	struct stree *stree;
+
+	data = sm->state->data;
+
+	clone = clone_sm(sm);
+	clone->state = alloc_compare_state(data->left, data->left_var, data->left_vsl,
+					   comparison,
+					   data->right, data->right_var, data->right_vsl);
+	free_slist(&clone->possible);
+	add_possible_sm(clone, clone);
+
+	stree = clone_stree(sm->pool);
+	overwrite_sm_state_stree(&stree, clone);
+	clone->pool = stree;
+
+	return clone;
+}
+
+static void create_fake_history(struct sm_state *sm, int op,
+			       struct state_list **true_stack,
+			       struct state_list **false_stack)
+{
+	struct sm_state *true_sm, *false_sm;
+	struct compare_data *data;
+	int true_comparison;
+	int false_comparison;
+
+	data = sm->state->data;
+
+	if (is_merged(sm) || sm->left || sm->right)
+		return;
+
+	true_comparison = comparison_intersection(data->comparison, op);
+	false_comparison = comparison_intersection(data->comparison, negate_comparison(op));
+
+	true_sm = clone_partial_sm(sm, true_comparison);
+	false_sm = clone_partial_sm(sm, false_comparison);
+
+	sm->merged = 1;
+	sm->left = true_sm;
+	sm->right = false_sm;
+
+	add_ptr_list(true_stack, true_sm);
+	add_ptr_list(false_stack, false_sm);
+}
+
 static void filter_by_sm(struct sm_state *sm, int op,
 		       struct state_list **true_stack,
-		       struct state_list **false_stack)
+		       struct state_list **false_stack,
+		       bool *useful)
 {
 	struct compare_data *data;
 	int is_true = 0;
@@ -2650,7 +2704,7 @@
 	if (!sm)
 		return;
 	data = sm->state->data;
-	if (!data || data->comparison == UNKNOWN_COMPARISON)
+	if (!data)
 		goto split;
 	if (data->comparison == IMPOSSIBLE_COMPARISON)
 		return;
@@ -2667,6 +2721,11 @@
 	if (data->comparison == comparison_intersection(data->comparison, negate_comparison(op)))
 		is_false = 1;
 
+	if (!is_true && !is_false && !is_merged(sm)) {
+		create_fake_history(sm, op, true_stack, false_stack);
+		return;
+	}
+
 	if (debug_implied()) {
 		sm_msg("%s: %s: op = '%s' negated '%s'. true_intersect = '%s' false_insersect = '%s' sm = '%s'",
 		       __func__,
@@ -2678,13 +2737,14 @@
 		       show_sm(sm));
 	}
 
+	*useful = true;
 	if (is_true)
 		add_ptr_list(true_stack, sm);
 	if (is_false)
 		add_ptr_list(false_stack, sm);
 split:
-	filter_by_sm(sm->left, op, true_stack, false_stack);
-	filter_by_sm(sm->right, op, true_stack, false_stack);
+	filter_by_sm(sm->left, op, true_stack, false_stack, useful);
+	filter_by_sm(sm->right, op, true_stack, false_stack, useful);
 }
 
 struct sm_state *comparison_implication_hook(struct expression *expr,
@@ -2695,6 +2755,7 @@
 	char *left, *right;
 	int op;
 	static char buf[256];
+	bool useful = false;
 
 	if (expr->type != EXPR_COMPARE)
 		return NULL;
@@ -2718,14 +2779,14 @@
 	}
 
 	snprintf(buf, sizeof(buf), "%s vs %s", left, right);
-	sm = get_sm_state(compare_id, buf, NULL);
+	sm = get_sm_state(comparison_id, buf, NULL);
 	if (!sm)
 		return NULL;
 	if (!sm->merged)
 		return NULL;
 
-	filter_by_sm(sm, op, true_stack, false_stack);
-	if (!*true_stack && !*false_stack)
+	filter_by_sm(sm, op, true_stack, false_stack, &useful);
+	if (!useful)
 		return NULL;
 
 	if (debug_implied())
